//////////////////////////////////////////////////////////////////////
//
//  FANCYFNT.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2009. All rights reserved.         
//  
//  Contents:
//      This sample program renders some text strings demonstrating the GRA
//      engine's GraStringAt() primitive.
//   
//////////////////////////////////////////////////////////////////////

#include "inkey.ch"
#include "dcdir.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "dll.ch"
#include "dccursor.ch"
#Include "thread.ch"
#include "class.ch"
#include "dmlb.ch"
#include "fileio.ch"
#include "dctree.ch"
#include "SystemMetrics.ch"
#include "appevent.ch"
*#include "axcdxcmx.ch"  // 䨪 ActiveX
#include "collat.ch"
#include "common.ch"
#include "dbedit.ch"
#include "dbfdbe.ch"
#include "dcapp.ch"
#include "dcbitmap.ch"
#include "dccargo.ch"
#include "dcdialog.ch"
#include "dcdir.ch"
#include "dcfiles.ch"
#include "dcgra.ch"
#include "dcgraph.ch"        // 䨪
#include "BdColors.Ch"       // 䨪
#include "dccolors.ch"       // 䨪
#include "dcprint.ch"        // 䨪
#include "dcicon.ch"
#include "dcmsg.ch"
#include "dcpick.ch"
#include "deldbe.ch"
#include "directry.ch"
#include "dmlb.ch"
#include "express.ch"
#include "fileio.ch"
#include "font.ch"
#include "gra.ch"
#include "inkey.ch"
#include "memvar.ch"
#include "natmsg.ch"
#include "prompt.ch"
#include '_dcdbfil.ch'
#include "set.ch"
#include "std.ch"
#include "xbp.ch"
#include '_dcappe.ch'
#include 'dcscope.ch'
#include '_dcstru.ch'
#include 'dcfields.ch'
#include 'dccolor.ch'
#include "Fileio.ch"    // Max_DB
*#include "rmchart.ch"   // 䨪 ActiveX
*#include "dcads.ch"
#include "test.ch"

#include "xb2net.ch" 
#pragma Library("XB2NET.LIB")

#pragma library( "ascom10.lib" )
#pragma library( "dclip1.lib" )
#pragma library( "dclip2.lib" )
#pragma library( "dclipx.lib" )
#pragma library( "xbtbase1.lib" )
#pragma library( "xbtbase2.lib" )
#pragma library( "xppui2.lib" )
*#pragma library( "XPPRT0.LIB" )

#Pragma Library("Taskbar.lib")

#xtranslate NTrim(<n>) =>  LTrim(Str(<n>))
#define USE_HTTPCLIENT // comment out to try Method2

//#include "Imgview.ch"
/*
 * We use user defined events
 */
#define  xbeDS_DirChanged           xbeP_User + 100
#define  xbeFS_FileMarked           xbeP_User + 101
#define  xbeFS_FileSelected         xbeP_User + 102

#define DCAREAMSG_1  'Invalid Expression in Index Key:'
/*
 * This directive calculates a centered position
 */
#xtrans  CenterPos( <aSize>, <aRefSize> ) => ;
         { Int( (<aRefSize>\[1] - <aSize>\[1]) / 2 ) ;
         , Int( (<aRefSize>\[2] - <aSize>\[2]) / 2 ) }

#define DC_RDDMSG_1 'Invalid RDD selection - '+cSuperRdd
#define DC_RDDMSG_2  'DBE Name      Description'
#define DC_RDDMSG_3  'Select a Database Driver'

#define ADSDBE_MEMOFILE_EXT    (DBE_USER+1) // RO
#define ADSDBE_INDEX_EXT       (DBE_USER+2) // RW
#define ADSDBE_TBL_MODE        (DBE_USER+3) // RW
#define ADSDBE_LOCK_MODE       (DBE_USER+4) // RW
#define ADSDBE_RIGHTS_MODE     (DBE_USER+5) // RW
#define ADSDBE_MEMOBLOCKSIZE   (DBE_USER+6) // RW
#define ADSDBE_PASSWORD        (DBE_USER+7) // RW

// Return types of ADSDBE_TBL_MODE
#define ADSDBE_NTX 1
#define ADSDBE_CDX 2
#define ADSDBE_ADT 3

// Excel Orientation
#DEFINE xlLandscape           2
#DEFINE xlPortrait            1

#DEFINE xlWorkbookNormal  -4143
#DEFINE xlCellTypeLastCell  11
#DEFINE SRCCOPY  0xCC0020              //  ன 䨪 

PROCEDURE AppSys
// 稩 ⮫ ⠥  ਫ
RETURN

******************************************************************************
PROCEDURE Main

   LOCAL GetList := {}, oStatic

   PRIVATE nEvent, mp1, mp2, oXbp            // ६  ᮡ⨩

   oPS := oStatic:lockPS()

   @0, 0 DCSAY "The save of the graphic file before rotation and after rotation" FONT ("12.HelveticalBold") SIZE 0

   @ 2,1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 153,35 ;
         OBJECT oStatic;
         EVAL {|| _PresSpace( oStatic ) }

   DCREAD GUI ;
      TITLE "The save of the graphic file before rotation and after rotation";
      FIT ;
      BUTTONS DCGUI_BUTTON_EXIT

RETURN

*************************************************
STATIC FUNCTION _PresSpace( oStatic )

   LOCAL oPS, oDevice

   PUBLIC X_MaxW := 1280, Y_MaxW := 640               //  ᪮   ᥫ

   oPS := XbpPresSpace():new()         // Create a PS
   oDevice := oStatic:winDevice()      // Get the device context
   oPS:create( oDevice )               // Link device context to PS
   oPS:SetViewPort( { 0, 0, X_MaxW, Y_MaxW } )
   oStatic:paint := {|mp1,mp2,obj| mp1 := GraTest(oPS) }

RETURN NIL

**************************************************************
FUNCTION GraTest(oPS)

   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF  
   GraSetAttrString( oPS, aAttrF ) 

   GraStringAt( oPS, {10,30}, "THE TEXT BEFORE THE ROTATION" )

   DC_Scrn2ImageFile( oPS, 'THE_TEXT_BEFORE_THE_ROTATION.bmp' )

   oFont := XbpFont():new():create("10.Arial Bold")
   GraSetFont(oPS , oFont)
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF  
   GraSetAttrString( oPS, aAttrF ) 

   nAngle = 10

   aMatrix := GraInitMatrix()
   FOR i:=1 TO nAngle
      GraRotate( oPS, aMatrix, 360/nAngle, {300, 300}, GRA_TRANSFORM_ADD )
      oPS:setGraTransform( aMatrix, GRA_TRANSFORM_REPLACE )
      GraStringAt( oPS, {100,100}, ALLTRIM(STR(i))+"TEXT AFTER ROTATION" )
   NEXT

   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)                        
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF
   GraSetAttrString( oPS, aAttrF ) 

   GraStringAt( oPS, { 50,50 }, 'TEXT AFTER ROTATION' )

   DC_Scrn2ImageFile( oPS, 'TEXT_AFTER_ROTATION.bmp' )

RETURN NIL

// EOF